;**************************************************************
;***    XMS0C.ASM                                           ***
;***                                                        ***
;***    function        XMS_XmBlk.lockXM(                   ***
;***                        var physAddr:   DWord)          ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Locks an extended memory block, preventing it from  ***
;***    moving in physical memory, and returns its          ***
;***    physical address.                                   ***
;***                                                        ***
;**************************************************************

        .model  large,pascal 

        include xmsdefs.asm 

        extrn   errno:WORD  
        extrn   xmsHandler:DWord

;
;   Define entry point
;
        public  XMS_XmBlk@lockXM

        .code

XMS_XmBlk@lockXM      proc    physAddr: Far Ptr DWord, handle:Far Ptr Word

        les     bx,handle
        mov     dx,es:[bx]          ; handle of block to lock
        mov     ah,XMSLockXM        ; Function code
        call    xmsHandler          ; call the guy

        or      ax,ax               ; AX=0 means error
        jz      errorReturn

        mov     ax,bx               ; Save LSW ofphysical address
        les     bx,physAddr         ; Get addr of long return val
        mov     es:[bx],ax          ; LSW physical address
        mov     es:[bx+2],dx        ; MSW physical address

        mov     ax,XMSErrOK         ; No error
        ret

errorReturn:
        mov     al,bl               ; Move error code to AL
        xor     ah,ah               ; Zero extend to 16 bits
        mov     errno,ax            ; Copy to errno
        ret

XMS_XmBlk@lockXM      endp          ; end of procedure

        end
